Index: src/java/org/jivesoftware/spark/ui/ChatContainer.java
===================================================================
--- src/java/org/jivesoftware/spark/ui/ChatContainer.java	(revision 10873)
+++ src/java/org/jivesoftware/spark/ui/ChatContainer.java	(working copy)
@@ -26,6 +26,7 @@
 import org.jivesoftware.spark.component.tabbedPane.SparkTab;
 import org.jivesoftware.spark.component.tabbedPane.SparkTabbedPane;
 import org.jivesoftware.spark.component.tabbedPane.SparkTabbedPaneListener;
+import org.jivesoftware.spark.preference.PreferenceManager;
 import org.jivesoftware.spark.ui.rooms.ChatRoomImpl;
 import org.jivesoftware.spark.ui.rooms.GroupChatRoom;
 import org.jivesoftware.spark.util.SwingTimerTask;
@@ -41,6 +42,7 @@
 import javax.swing.JComponent;
 import javax.swing.JFrame;
 import javax.swing.JOptionPane;
+import javax.swing.JPanel;
 import javax.swing.JPopupMenu;
 import javax.swing.JTabbedPane;
 import javax.swing.KeyStroke;
@@ -89,6 +91,8 @@
 
     private ChatFrame chatFrame;
     
+    private JFrame externalizedFrame;
+    
     private LocalPreferences localPref;
 
     private final TimerTask focusTask;
@@ -237,7 +241,6 @@
      */
     public synchronized void addChatRoom(final ChatRoom room) {
         createFrameIfNeeded();
-
         room.setBorder(BorderFactory.createMatteBorder(1, 0, 0, 0, Color.LIGHT_GRAY));
         AndFilter presenceFilter = new AndFilter(new PacketTypeFilter(Presence.class), new FromContainsFilter(room.getRoomname()));
 
@@ -252,7 +255,6 @@
             }
         };
 
-
         SparkManager.getConnection().addPacketListener(myListener, presenceFilter);
 
         // Add to PresenceMap
@@ -268,19 +270,19 @@
         else {
             tooltip = room.getRoomname();
         }
-
+        
         // Create ChatRoom UI and dock
         SparkTab tab = addTab(room.getTabTitle(), room.getTabIcon(), room, tooltip);
-        tab.addMouseListener(new MouseAdapter() {
-            public void mouseReleased(MouseEvent e) {
-                checkTabPopup(e);
-            }
-
-            public void mousePressed(MouseEvent e) {
-                checkTabPopup(e);
-            }
-        });
-
+	     tab.addMouseListener(new MouseAdapter() {
+	         public void mouseReleased(MouseEvent e) {
+	             checkTabPopup(e);
+	         }
+	         public void mousePressed(MouseEvent e) {
+	             checkTabPopup(e);
+	         }
+	     });
+       
+	     
         room.addMessageListener(this);
 
         // Remove brand panel
@@ -289,15 +291,14 @@
             chatFrame.setTitle(room.getRoomTitle());
         }
 
-
         final TimerTask visibleTask = new SwingTimerTask() {
-            public void doRun() {
-                checkVisibility(room);
-            }
+          public void doRun() {
+              checkVisibility(room);
+          }
         };
 
         TaskEngine.getInstance().schedule(visibleTask, 100);
-
+	
         // Add to ChatRoomList
         chatRoomList.add(room);
 
@@ -306,7 +307,10 @@
 
         // Focus Chat
         focusChat();
+        
 
+	     
+        
         // Add Room listeners to override issue with input maps and keybinding on the mac.
         if (Spark.isMac()) {
             room.getChatInputEditor().addKeyListener(this);
@@ -361,6 +365,7 @@
     }
 
     private void checkVisibility(Component component) {
+   	
         if (!chatFrame.isVisible() && SparkManager.getMainWindow().isFocusOwner()) {
             chatFrame.setState(Frame.NORMAL);
             chatFrame.setVisible(true);
@@ -416,7 +421,8 @@
         ChatRoom activeChatRoom = null;        
         
         try {
-            activeChatRoom = getActiveChatRoom();
+      	  	if(SparkManager.getChatManager().getChatContainer().getTabCount() != 0)
+      	  		activeChatRoom = getActiveChatRoom();
         }
         catch (ChatRoomNotFoundException e1) {
             Log.error(e1);
@@ -452,26 +458,30 @@
         }
         else if (!chatFrame.isVisible()) {
             // Set to new tab.
-            int tabLocation = indexOfComponent(chatRoom);
-            setSelectedIndex(tabLocation);
-
-            if (Spark.isWindows()) {
-                chatFrame.setFocusableWindowState(false);
-                chatFrame.setState(Frame.ICONIFIED);
-            }
-            chatFrame.setVisible(true);
-            chatFrame.setFocusableWindowState(true);
-
-            // If the ContactList is in the tray, we need better notification by flashing
-            // the chatframe.
-            if (!SparkManager.getMainWindow().isVisible()) {
-                groupChatMessageCheck(chatRoom, customMsg, customMsgText, customMsgTitle);
-            }
-            else if (chatFrame.getState() == Frame.ICONIFIED) {
-                groupChatMessageCheck(chatRoom, customMsg, customMsgText, customMsgTitle);
-            }
-
-            chatFrame.setTitle(chatRoom.getRoomTitle());
+      	  	LocalPreferences pref = SettingsManager.getLocalPreferences();
+      	  	if(SparkManager.getExternalizedFrame(chatRoom.getTabTitle()) == null && !pref.isTabsExternalizedOn())
+      	  	{
+	            int tabLocation = indexOfComponent(chatRoom);
+	            setSelectedIndex(tabLocation);
+	
+	            if (Spark.isWindows()) {
+	                chatFrame.setFocusableWindowState(false);
+	                chatFrame.setState(Frame.ICONIFIED);
+	            }
+	            chatFrame.setVisible(true);
+	            chatFrame.setFocusableWindowState(true);
+	
+	            // If the ContactList is in the tray, we need better notification by flashing
+	            // the chatframe.
+	            if (!SparkManager.getMainWindow().isVisible()) {
+	                groupChatMessageCheck(chatRoom, customMsg, customMsgText, customMsgTitle);
+	            }
+	            else if (chatFrame.getState() == Frame.ICONIFIED) {
+	                groupChatMessageCheck(chatRoom, customMsg, customMsgText, customMsgTitle);
+	            }
+	
+	            chatFrame.setTitle(chatRoom.getRoomTitle());
+      	  	}
         }
         else if (chatRoom != activeChatRoom) {
             groupChatMessageCheck(chatRoom, customMsg, customMsgText, customMsgTitle);
@@ -557,7 +567,7 @@
      * @throws ChatRoomNotFoundException if the room was not found.
      */
     public ChatRoom getChatRoom(String roomName) throws ChatRoomNotFoundException {
-        for (int i = 0; i < getTabCount(); i++) {
+   	 for (int i = 0; i < getTabCount(); i++) {
             ChatRoom room = null;
             try {
                 room = getChatRoom(i);
@@ -565,12 +575,31 @@
             catch (ChatRoomNotFoundException e1) {
                 // Ignore
             }
-
-            if (room != null && room.getRoomname().equalsIgnoreCase(roomName) && room.isActive()) {
-                return room;
+            
+            String room_roomname = room.getRoomname();
+            if(room.getRoomname().contains("/spark"))
+            {
+            	String[] roomname = room_roomname.split("/spark");
+            	room_roomname = roomname[0];
+            }
+            
+            if (room != null && room_roomname.equalsIgnoreCase(roomName) && room.isActive()) {
+            	return room; 
             }
         }
-        throw new ChatRoomNotFoundException(roomName + " not found.");
+   	  try
+   	  {
+	   	  String roomTitle = SparkManager.getContactList().getContactItemByJID(roomName).getDisplayName();
+	        if(SparkManager.getExternalizedChatRoom(roomTitle) != null)
+	        {
+	       		return SparkManager.getExternalizedChatRoom(roomTitle);
+	        }
+   	  }
+   	  catch(Exception e)
+   	  {
+   		  throw new ChatRoomNotFoundException(roomName + " not found.");
+   	  }
+   	  throw new ChatRoomNotFoundException(roomName + " not found.");
     }
 
     /**
@@ -631,11 +660,19 @@
      * @param room the ChatRoom to activate.
      */
     public void activateChatRoom(ChatRoom room) {
-        int tabLocation = indexOfComponent(room);
+        if(SparkManager.getExternalizedChatRoom(room.getTabTitle()) != null)
+        {
+      	  SparkManager.getExternalizedFrame(room.getTabTitle()).toFront();
+      	  SparkManager.getExternalizedFrame(room.getTabTitle()).requestFocus();
+        }
+        else
+        {
+   	  int tabLocation = indexOfComponent(room);
         setSelectedIndex(tabLocation);
 
         chatFrame.bringFrameIntoFocus();
         focusChat();
+        }
     }
 
     /**
@@ -661,7 +698,7 @@
      */
     public void messageReceived(ChatRoom room, Message message) {
         room.increaseUnreadMessageCount();
-
+        SparkManager.getWorkspace().getTranscriptPlugin().persistChatRoom(room);
         fireNotifyOnMessage(room, false, null, null);
     }
     
@@ -918,7 +955,7 @@
                         // Check notifications.
                         if (SettingsManager.getLocalPreferences().isChatRoomNotificationsOn() || !(comp instanceof GroupChatRoom)) {
                             if (comp instanceof ChatRoom) {
-                                checkNotificationPreferences((ChatRoom)comp, customMsg, customMsgText, customMsgTitle);
+                                checkNotificationPreferences((ChatRoom)comp, customMsg, customMsgText, customMsgTitle, false);
                             }
                         }
 
@@ -979,26 +1016,47 @@
      * @param fileTName the file name being transfered (if fileTransfer applies)
      *
      */
-    private void checkNotificationPreferences(final ChatRoom room, boolean customMsg, String customMsgText, String customMsgTitle) {
+    public void checkNotificationPreferences(final ChatRoom room, boolean customMsg, String customMsgText, String customMsgTitle, boolean externalChatroom) {
         LocalPreferences pref = SettingsManager.getLocalPreferences();
+        System.out.println("lelelelelelelelelee");
         if (pref.getWindowTakesFocus()) {
-            chatFrame.setState(Frame.NORMAL);
-            chatFrame.setVisible(true);
+      	  if(externalChatroom)
+           {
+         		externalizedFrame = SparkManager.getExternalizedFrame(room.getTabTitle());
+   	      	externalizedFrame.setVisible(true);
+   	      	externalizedFrame.setState(Frame.NORMAL);
+           }
+      	  else
+      	  {
+      		  	chatFrame.setState(Frame.NORMAL);
+           		chatFrame.setVisible(true);
+        	  }
         }
-
         if (pref.getShowToasterPopup()) {
             SparkToaster toaster = new SparkToaster();
-            toaster.setCustomAction(new AbstractAction() {
-                public void actionPerformed(ActionEvent actionEvent) {
-                    chatFrame.setState(Frame.NORMAL);
-                    chatFrame.setVisible(true);
-                    int tabLocation = indexOfComponent(room);
-                    if (tabLocation != -1) {
-                        setSelectedIndex(tabLocation);
-                    }
-                }
-            });
-
+            if(externalChatroom)
+            {
+	            toaster.setCustomAction(new AbstractAction() {
+	               public void actionPerformed(ActionEvent actionEvent) {
+	              	  externalizedFrame.setState(Frame.NORMAL);
+	              	  externalizedFrame.setVisible(true);
+	               }
+	            });
+            }
+            else
+            {
+	            toaster.setCustomAction(new AbstractAction() {
+	                public void actionPerformed(ActionEvent actionEvent) {
+	                    chatFrame.setState(Frame.NORMAL);
+	                    chatFrame.setVisible(true);
+	                    int tabLocation = indexOfComponent(room);
+	                    if (tabLocation != -1) {
+	                        setSelectedIndex(tabLocation);
+	                    }
+	                }
+	            });	
+            }
+            
             toaster.setDisplayTime(5000);
             toaster.setBorder(BorderFactory.createBevelBorder(0));
             
@@ -1036,7 +1094,7 @@
         localPref = SettingsManager.getLocalPreferences();
         boolean isGroupChat = chatRoom.getChatType() == Message.Type.groupchat;
         int size = chatRoom.getTranscripts().size();
-        
+       
         // is this a group chat message and is my name in it?
         if (isGroupChat) {
             // is a group chat, perform some functions
@@ -1088,7 +1146,7 @@
             return;
         } else {
             // normal personal chat
-            Message lastChatMessage = chatRoom.getTranscripts().get(size - 1);
+            Message lastChatMessage = SparkManager.getWorkspace().getTranscriptPlugin().getLastMessage();
             String finalRoomName = chatRoom.getRoomTitle();
             
             boolean customMsgS = true;
@@ -1110,10 +1168,11 @@
     }
 
     private void createFrameIfNeeded() {
-        if (chatFrame != null) {
+   	  if (chatFrame != null) {
             return;
         }
-        LocalPreferences pref = SettingsManager.getLocalPreferences();
+   	  
+   	  LocalPreferences pref = SettingsManager.getLocalPreferences();
         if (pref.isDockingEnabled()) {
             chatFrame = MainWindow.getInstance();
         }
@@ -1170,8 +1229,6 @@
      * Brings the chat into focus.
      */
     public void focusChat() {
-
-
         TaskEngine.getInstance().schedule(focusTask, 50);
     }
 
@@ -1368,5 +1425,10 @@
 
         return messageCount;
     }
+    
+    public List<ChatRoomListener> getChatRoomListener()
+    {
+   	 return chatRoomListeners;
+    }
 }
 
Index: src/java/org/jivesoftware/spark/ui/ChatFrame.java
===================================================================
--- src/java/org/jivesoftware/spark/ui/ChatFrame.java	(revision 10873)
+++ src/java/org/jivesoftware/spark/ui/ChatFrame.java	(working copy)
@@ -177,8 +177,8 @@
     /**
      * Shake it, come on now, shake that frame.
      */
-    public void buzz() {
-        ShakeWindow d = new ShakeWindow(this);
+    public void buzz(JFrame frame) {
+        ShakeWindow d = new ShakeWindow(frame);
         d.startShake();
     }
 
Index: src/java/org/jivesoftware/spark/ui/ChatRoom.java
===================================================================
--- src/java/org/jivesoftware/spark/ui/ChatRoom.java	(revision 10873)
+++ src/java/org/jivesoftware/spark/ui/ChatRoom.java	(working copy)
@@ -21,8 +21,10 @@
 import org.jivesoftware.spark.component.BackgroundPanel;
 import org.jivesoftware.spark.component.RolloverButton;
 import org.jivesoftware.spark.plugin.ContextMenuListener;
+import org.jivesoftware.spark.ui.rooms.GroupChatRoom;
 import org.jivesoftware.spark.util.GraphicUtils;
 import org.jivesoftware.spark.util.log.Log;
+import org.jivesoftware.sparkimpl.plugin.alerts.SparkToaster;
 import org.jivesoftware.sparkimpl.settings.local.LocalPreferences;
 import org.jivesoftware.sparkimpl.settings.local.SettingsManager;
 
@@ -32,6 +34,7 @@
 import javax.swing.Icon;
 import javax.swing.JButton;
 import javax.swing.JComponent;
+import javax.swing.JFrame;
 import javax.swing.JLabel;
 import javax.swing.JPanel;
 import javax.swing.JPopupMenu;
@@ -49,6 +52,7 @@
 import java.awt.Color;
 import java.awt.Component;
 import java.awt.FlowLayout;
+import java.awt.Frame;
 import java.awt.GridBagConstraints;
 import java.awt.GridBagLayout;
 import java.awt.Insets;
@@ -74,15 +78,15 @@
     private final JSplitPane splitPane;
     private JSplitPane verticalSplit;
 
-    private final JLabel notificationLabel;
-    private final TranscriptWindow transcriptWindow;
-    private final ChatAreaSendField chatAreaButton;
-    private final ChatToolBar toolbar;
-    private final JScrollPane textScroller;
-    private final JPanel bottomPanel;
-    private final JPanel editorBar;
+    private final  JLabel notificationLabel;
+    private final  TranscriptWindow transcriptWindow;
+    private final  ChatAreaSendField chatAreaButton;
+    private final  ChatToolBar toolbar;
+    private final  JScrollPane textScroller;
+    private final  JPanel bottomPanel;
+    private final  JPanel editorBar;
     private JPanel chatWindowPanel;
-
+    private JFrame externalizedFrame;
     private int unreadMessageCount;
 
     private boolean mousePressed;
@@ -104,7 +108,7 @@
     /**
      * Initializes the base layout and base background color.
      */
-    protected ChatRoom() {
+   public ChatRoom() {
         chatPanel = new JPanel(new GridBagLayout());
         transcriptWindow = new TranscriptWindow();
         splitPane = new JSplitPane();
@@ -178,12 +182,11 @@
 
         getTranscriptWindow().setTransferHandler(transferHandler);
         getChatInputEditor().setTransferHandler(transferHandler);
-
         add(toolbar, new GridBagConstraints(0, 0, 1, 1, 1.0, 0.0, GridBagConstraints.EAST, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 0), 0, 0));
 
         // Add Connection Listener
         SparkManager.getConnection().addConnectionListener(this);
-
+        
         // Add Focus Listener
         addFocusListener(this);
     }
@@ -326,8 +329,10 @@
         SparkManager.getChatManager().fireGlobalMessageReceievedListeners(this, message);
 
         addToTranscript(message, true);
-
+        
         fireMessageReceived(message);
+
+        SparkManager.getWorkspace().getTranscriptPlugin().persistChatRoom(this);    
     }
 
 
@@ -345,8 +350,6 @@
         newMessage.setFrom(message.getFrom());
         newMessage.setBody(message.getBody());
         
-        
-        
         newMessage.setProperty("date", new Date());
 
         transcript.add(newMessage);
@@ -466,13 +469,15 @@
      * @param e the KeyEvent
      */
     private void checkForEnter(KeyEvent e) {
-        final KeyStroke keyStroke = KeyStroke.getKeyStroke(e.getKeyCode(), e.getModifiers());
+   	 final KeyStroke keyStroke = KeyStroke.getKeyStroke(e.getKeyCode(), e.getModifiers());
         if (!keyStroke.equals(KeyStroke.getKeyStroke(KeyEvent.VK_ENTER, KeyEvent.SHIFT_DOWN_MASK)) &&
                 e.getKeyChar() == KeyEvent.VK_ENTER) {
             e.consume();
             sendMessage();
             getChatInputEditor().setText("");
             getChatInputEditor().setCaretPosition(0);
+            
+            SparkManager.getWorkspace().getTranscriptPlugin().persistChatRoom(this);
         }
         else if (keyStroke.equals(KeyStroke.getKeyStroke(KeyEvent.VK_ENTER, KeyEvent.SHIFT_DOWN_MASK))) {
             final Document document = getChatInputEditor().getDocument();
@@ -514,6 +519,9 @@
         for (MessageListener messageListener : messageListeners) {
             messageListener.messageReceived(this, message);
         }
+        
+        if(SparkManager.getExternalizedFrame(this.getTabTitle()) != null)
+      	  SparkManager.getChatManager().getChatContainer().checkNotificationPreferences(this, false, null, null, true);
     }
 
     /**
@@ -733,7 +741,6 @@
         return toolbar;
     }
 
-
     public void insertUpdate(DocumentEvent e) {
         // Meant to be overriden
         checkForText(e);
Index: src/java/org/jivesoftware/spark/ui/ContactGroup.java
===================================================================
--- src/java/org/jivesoftware/spark/ui/ContactGroup.java	(revision 10873)
+++ src/java/org/jivesoftware/spark/ui/ContactGroup.java	(working copy)
@@ -18,6 +18,7 @@
 import org.jivesoftware.spark.component.VerticalFlowLayout;
 import org.jivesoftware.spark.component.panes.CollapsiblePane;
 import org.jivesoftware.spark.component.renderer.JPanelRenderer;
+import org.jivesoftware.spark.ui.rooms.ChatRoomImpl;
 import org.jivesoftware.spark.util.GraphicUtils;
 import org.jivesoftware.spark.util.ModelUtil;
 import org.jivesoftware.spark.util.log.Log;
@@ -28,6 +29,7 @@
 import java.awt.Component;
 import java.awt.Dimension;
 import java.awt.Font;
+import java.awt.Frame;
 import java.awt.GridBagConstraints;
 import java.awt.GridBagLayout;
 import java.awt.Insets;
@@ -46,6 +48,7 @@
 import java.util.List;
 
 import javax.swing.DefaultListModel;
+import javax.swing.JFrame;
 import javax.swing.JList;
 import javax.swing.JPanel;
 import javax.swing.Timer;
@@ -117,7 +120,8 @@
             public void mouseClicked(MouseEvent e) {
 	             if(e.getButton() == MouseEvent.BUTTON1)
 	             {
-	           	 	contactList.saveState();
+	            	 contactList =  Workspace.getInstance().getContactList();
+	           	 	 contactList.saveState(); 
 	             }
             }
 
@@ -158,8 +162,6 @@
 
         // Add Popup Window
         addPopupWindow();
-        
-       
     }
 
     /**
@@ -174,7 +176,6 @@
         // Build new ContactItem
         final ContactItem offlineItem = new ContactItem(alias, nickname, jid);
         offlineItem.setGroupName(getGroupName());
-
         final Presence offlinePresence = PresenceManager.getPresence(jid);
         offlineItem.setPresence(offlinePresence);
 
@@ -277,11 +278,9 @@
     public void addContactItem(ContactItem item) {
         // Remove from offline group if it exists
         removeOfflineContactItem(item.getJID());
-
         if (model.contains(noContacts)) {
             model.remove(0);
         }
-
         if (Res.getString("group.offline").equals(groupName)) {
             item.getNicknameLabel().setFont(new Font("Dialog", Font.PLAIN, 11));
             item.getNicknameLabel().setForeground(Color.GRAY);
@@ -464,7 +463,7 @@
         ContactItem item = (ContactItem)o;
 
         if (e.getClickCount() == 2) {
-            fireContactItemDoubleClicked(item);
+      	  	fireContactItemDoubleClicked(item);
         }
         else if (e.getClickCount() == 1) {
             fireContactItemClicked(item);
@@ -772,9 +771,9 @@
      * @return the preferred dimension
      */
     public Dimension getPreferredSize() {
-        final Dimension size = super.getPreferredSize();
-        size.width = 0;
-        return size;
+	     final Dimension size = super.getPreferredSize();
+	     size.width = 0;
+	     return size;
     }
 
     /**
Index: src/java/org/jivesoftware/spark/ui/ContactItem.java
===================================================================
--- src/java/org/jivesoftware/spark/ui/ContactItem.java	(revision 10873)
+++ src/java/org/jivesoftware/spark/ui/ContactItem.java	(working copy)
@@ -1,11 +1,7 @@
 /**
- * $Revision: $
- * $Date: $
- *
- * Copyright (C) 2006 Jive Software. All rights reserved.
- *
- * This software is published under the terms of the GNU Lesser Public License (LGPL),
- * a copy of which is included in this distribution.
+ * $Revision: $ $Date: $ Copyright (C) 2006 Jive Software. All rights reserved.
+ * This software is published under the terms of the GNU Lesser Public License
+ * (LGPL), a copy of which is included in this distribution.
  */
 
 package org.jivesoftware.spark.ui;
@@ -21,6 +17,7 @@
 import org.jivesoftware.spark.ChatManager;
 import org.jivesoftware.spark.PresenceManager;
 import org.jivesoftware.spark.SparkManager;
+import org.jivesoftware.spark.ui.rooms.ChatRoomImpl;
 import org.jivesoftware.spark.util.GraphicUtils;
 import org.jivesoftware.spark.util.ModelUtil;
 import org.jivesoftware.spark.util.log.Log;
@@ -31,6 +28,7 @@
 import org.jivesoftware.sparkimpl.plugin.layout.LayoutSettingsManager;
 
 import javax.swing.*;
+
 import java.awt.*;
 import java.io.File;
 import java.net.MalformedURLException;
